GG: GG Namespace Reference

GG

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Namespace List
- Namespace Members

Classes | Typedefs | Enumerations | Functions | Variables
GG Namespace Reference

## Classes
struct | AdamDialogResult
class | AdamModalDialog
class | BrowseInfoWnd
class | TextBoxBrowseInfoWnd
class | Button
class | StateButton
class | RadioButtonGroup
struct | Clr
class | Control
class | Cursor
class | TextureCursor
struct | HSVClr
class | HueSaturationPicker
class | ValuePicker
class | ColorDlg
class | FileDlg
class | ThreeButtonDlg
class | DropDownList
class | DynamicGraphic
class | Edit
struct | EnumMapBase
struct | EnumMap
struct | ModalDialogResult
struct | EventPumpState
class | EventPumpBase
class | EventPump
class | ModalEventPump
class | ExceptionBase
struct | is_flag_type
class | FlagSpec
class | Flags
class | Font
class | FontManager
class | GroupBox
class | GUI
class | Layout
class | ListBox
struct | MenuItem
class | MenuBar
class | PopupMenu
class | MultiEdit
class | OgreGUI
class | OgreGUIInputPlugin
class | PluginInterface
class | PluginManager
struct | Pt
struct | Rect
class | Scroll
class | SDLGUI
class | Slider
class | Spin
class | StaticGraphic
class | StyleFactory
class | OverlayWnd
class | TabWnd
class | TabBar
class | TextControl
class | Texture
class | SubTexture
class | TextureManager
class | Timer
struct | UnicodeCharset
class | Wnd
class | WndEvent
class | ZList
class | StrSize
class | CPSize
class | X
class | Y

## Typedefs
typedef boost::function< bool(adobe::name_t, const adobe::any_regular_t &)> | AdamDialogActionCallback
typedef boost::function< bool(adobe::name_t, const adobe::any_regular_t &)> | ButtonHandler

## Enumerations
enum | AdamDialogDisplayOption { ADAM_DIALOG_DISPLAY_ALWAYS, ADAM_DIALOG_DISPLAY_AS_NEEDED, ADAM_DIALOG_DISPLAY_NEVER }
enum | WndRegion
enum | Orientation { VERTICAL, HORIZONTAL }
enum | StateButtonStyle { SBSTYLE_3D_XBOX, SBSTYLE_3D_CHECKBOX, SBSTYLE_3D_RADIO, SBSTYLE_3D_BUTTON, SBSTYLE_3D_ROUND_BUTTON, SBSTYLE_3D_TOP_ATTACHED_TAB, SBSTYLE_3D_TOP_DETACHED_TAB }
enum | SliderLineStyle
enum | TabBarStyle { TAB_BAR_ATTACHED, TAB_BAR_DETACHED }
enum | Key

## Functions
| GG_FLAG_TYPE (Alignment)
void | KeypadKeyToPrintable (Key &key, Flags< ModKey > mod_keys)
Clr | FloatClr (float r, float g, float b, float a)
bool | operator== (const Clr &rhs, const Clr &lhs)
bool | operator!= (const Clr &rhs, const Clr &lhs)
GG_API void | glColor (Clr clr)
GG_API void | glVertex (const Pt &pt)
GG_API void | glVertex (X x, Y y)
GG_API void | glVertex (X_d x, Y_d y)
GG_API void | glVertex (X x, Y_d y)
GG_API void | glVertex (X_d x, Y y)
GG_API Clr | LightColor (Clr clr)
GG_API Clr | DarkColor (Clr clr)
GG_API Clr | DisabledColor (Clr clr)
GG_API void | BeginScissorClipping (Pt ul, Pt lr)
GG_API void | EndScissorClipping ()
GG_API void | BeginStencilClipping (Pt inner_ul, Pt inner_lr, Pt outer_ul, Pt outer_lr)
GG_API void | EndStencilClipping ()
GG_API void | FlatRectangle (Pt ul, Pt lr, Clr color, Clr border_color, unsigned int border_thick=2)
GG_API void | BeveledRectangle (Pt ul, Pt lr, Clr color, Clr border_color, bool up, unsigned int bevel_thick=2, bool bevel_left=true, bool bevel_top=true, bool bevel_right=true, bool bevel_bottom=true)
GG_API void | FlatCheck (Pt ul, Pt lr, Clr color)
GG_API void | BeveledCheck (Pt ul, Pt lr, Clr color)
GG_API void | FlatX (Pt ul, Pt lr, Clr color)
GG_API void | BeveledX (Pt ul, Pt lr, Clr color)
GG_API void | Bubble (Pt ul, Pt lr, Clr color, bool up=true)
GG_API void | FlatCircle (Pt ul, Pt lr, Clr color, Clr border_color, unsigned thick=2)
GG_API void | BeveledCircle (Pt ul, Pt lr, Clr color, Clr border_color, bool up=true, unsigned int bevel_thick=2)
GG_API void | FlatRoundedRectangle (Pt ul, Pt lr, Clr color, Clr border_color, unsigned int corner_radius=5, unsigned int border_thick=2)
GG_API void | BeveledRoundedRectangle (Pt ul, Pt lr, Clr color, Clr border_color, bool up, unsigned int corner_radius=5, unsigned int bevel_thick=2)
GG_API void | BubbleRectangle (Pt ul, Pt lr, Clr color, bool up, unsigned int corner_radius=5)
template<class E >
EnumMap< E > | GetEnumMap ()
ModalDialogResult | ExecuteModalDialog (std::istream &eve_definition, std::istream &adam_definition, ButtonHandler handler)
Wnd * | MakeDialog (std::istream &eve_definition, std::istream &adam_definition, ButtonHandler handler)
template<class FlagType >
std::ostream & | operator<< (std::ostream &os, Flags< FlagType > flags)
template<class FlagType >
Flags< FlagType > | operator| (Flags< FlagType > lhs, Flags< FlagType > rhs)
template<class FlagType >
Flags< FlagType > | operator| (Flags< FlagType > lhs, FlagType rhs)
template<class FlagType >
Flags< FlagType > | operator| (FlagType lhs, Flags< FlagType > rhs)
template<class FlagType >
boost::enable_if< is_flag_type < FlagType >, Flags< FlagType > >::type | operator| (FlagType lhs, FlagType rhs)
template<class FlagType >
Flags< FlagType > | operator& (Flags< FlagType > lhs, Flags< FlagType > rhs)
template<class FlagType >
Flags< FlagType > | operator& (Flags< FlagType > lhs, FlagType rhs)
template<class FlagType >
Flags< FlagType > | operator& (FlagType lhs, Flags< FlagType > rhs)
template<class FlagType >
boost::enable_if< is_flag_type < FlagType >, Flags< FlagType > >::type | operator& (FlagType lhs, FlagType rhs)
template<class FlagType >
Flags< FlagType > | operator^ (Flags< FlagType > lhs, Flags< FlagType > rhs)
template<class FlagType >
Flags< FlagType > | operator^ (Flags< FlagType > lhs, FlagType rhs)
template<class FlagType >
Flags< FlagType > | operator^ (FlagType lhs, Flags< FlagType > rhs)
template<class FlagType >
boost::enable_if< is_flag_type < FlagType >, Flags< FlagType > >::type | operator^ (FlagType lhs, FlagType rhs)
template<class FlagType >
Flags< FlagType > | operator~ (Flags< FlagType > flags)
template<class FlagType >
boost::enable_if< is_flag_type < FlagType >, Flags< FlagType > >::type | operator~ (FlagType flag)
GG_API std::string | RgbaTag (const Clr &c)
GG_API std::ostream & | operator<< (std::ostream &os, const Font::Substring &substr)
GG_API CPSize | CodePointIndexOf (std::size_t line, CPSize index, const std::vector< Font::LineData > &line_data)
GG_API StrSize | StringIndexOf (std::size_t line, CPSize index, const std::vector< Font::LineData > &line_data)
GG_API std::pair< std::size_t, CPSize > | LinePositionOf (CPSize index, const std::vector< Font::LineData > &line_data)
GG_API FontManager & | GetFontManager ()
| GG_EXCEPTION (FailedFTLibraryInit)
| GG_FLAG_TYPE (TextFormat)
GG_API bool | MatchesOrContains (const Wnd *lwnd, const Wnd *rwnd)
| GG_FLAG_TYPE (ListBoxStyle)
| GG_FLAG_TYPE (MultiEditStyle)
GG_API PluginManager & | GetPluginManager ()
GG_API bool | operator== (const Pt &lhs, const Pt &rhs)
GG_API bool | operator!= (const Pt &lhs, const Pt &rhs)
GG_API bool | operator< (const Pt &lhs, const Pt &rhs)
GG_API bool | operator> (const Pt &lhs, const Pt &rhs)
GG_API bool | operator<= (const Pt &lhs, const Pt &rhs)
GG_API bool | operator>= (const Pt &lhs, const Pt &rhs)
GG_API Pt | operator+ (const Pt &lhs, const Pt &rhs)
GG_API Pt | operator- (const Pt &lhs, const Pt &rhs)
GG_API std::ostream & | operator<< (std::ostream &os, const Pt &pt)
GG_API bool | operator== (const Rect &lhs, const Rect &rhs)
GG_API bool | operator!= (const Rect &lhs, const Rect &rhs)
GG_API Rect | operator+ (const Rect &rect, const Pt &pt)
GG_API Rect | operator- (const Rect &rect, const Pt &pt)
GG_API Rect | operator+ (const Pt &pt, const Rect &rect)
GG_API Rect | operator- (const Pt &pt, const Rect &rect)
GG_API std::ostream & | operator<< (std::ostream &os, const Rect &rect)
GG_ENUM_MAP_END GG_API void | SignalScroll (const Scroll &scroll, bool stopped)
template<class SigT >
boost::signals::connection | Connect (SigT &sig, const typename SigT::slot_type &_slot, boost::signals::connect_position at=boost::signals::at_back)
template<class SigT >
boost::signals::connection | Connect (SigT &sig, const typename SigT::slot_type &_slot, int grp, boost::signals::connect_position at=boost::signals::at_back)
| GG_FLAG_TYPE (GraphicStyle)
int | Value (int i)
double | Value (double d)
std::size_t | Value (std::size_t s)
TextureManager & | GetTextureManager ()
GG_API bool | operator== (const UnicodeCharset &lhs, const UnicodeCharset &rhs)
GG_API bool | operator< (const UnicodeCharset &lhs, const UnicodeCharset &rhs)
GG_API const std::vector < UnicodeCharset > & | AllUnicodeCharsets ()
GG_API std::set< UnicodeCharset > | UnicodeCharsetsToRender (const std::string &str)
GG_API const UnicodeCharset * | CharsetContaining (boost::uint32_t c)
GG_API const UnicodeCharset * | CharsetWithName (const std::string &name)
| GG_FLAG_TYPE (WndFlag)

## Variables
GG_API const Alignment | ALIGN_NONE
GG_API const Alignment | ALIGN_VCENTER
GG_API const Alignment | ALIGN_TOP
GG_API const Alignment | ALIGN_BOTTOM
GG_API const Alignment | ALIGN_CENTER
GG_API const Alignment | ALIGN_LEFT
GG_API const Alignment | ALIGN_RIGHT
GG_API const TextFormat | FORMAT_NONE
GG_API const TextFormat | FORMAT_VCENTER
GG_API const TextFormat | FORMAT_TOP
GG_API const TextFormat | FORMAT_BOTTOM
GG_API const TextFormat | FORMAT_CENTER
GG_API const TextFormat | FORMAT_LEFT
GG_API const TextFormat | FORMAT_RIGHT
GG_API const TextFormat | FORMAT_WORDBREAK
GG_API const TextFormat | FORMAT_LINEWRAP
GG_API const TextFormat | FORMAT_IGNORETAGS
GG_API const ListBoxStyle | LIST_NONE
GG_API const ListBoxStyle | LIST_VCENTER
GG_API const ListBoxStyle | LIST_TOP
GG_API const ListBoxStyle | LIST_BOTTOM
GG_API const ListBoxStyle | LIST_CENTER
GG_API const ListBoxStyle | LIST_LEFT
GG_API const ListBoxStyle | LIST_RIGHT
GG_API const ListBoxStyle | LIST_NOSORT
GG_API const ListBoxStyle | LIST_SORTDESCENDING
GG_API const ListBoxStyle | LIST_NOSEL
GG_API const ListBoxStyle | LIST_SINGLESEL
GG_API const ListBoxStyle | LIST_QUICKSEL
GG_API const ListBoxStyle | LIST_USERDELETE
GG_API const ListBoxStyle | LIST_BROWSEUPDATES
GG_API const MultiEditStyle | MULTI_NONE
GG_API const MultiEditStyle | MULTI_WORDBREAK
GG_API const MultiEditStyle | MULTI_LINEWRAP
GG_API const MultiEditStyle | MULTI_VCENTER
GG_API const MultiEditStyle | MULTI_TOP
GG_API const MultiEditStyle | MULTI_BOTTOM
GG_API const MultiEditStyle | MULTI_CENTER
GG_API const MultiEditStyle | MULTI_LEFT
GG_API const MultiEditStyle | MULTI_RIGHT
GG_API const MultiEditStyle | MULTI_READ_ONLY
GG_API const MultiEditStyle | MULTI_TERMINAL_STYLE
GG_API const MultiEditStyle | MULTI_INTEGRAL_HEIGHT
GG_API const MultiEditStyle | MULTI_NO_VSCROLL
GG_API const MultiEditStyle | MULTI_NO_HSCROLL
GG_API const Flags < MultiEditStyle > | MULTI_NO_SCROLL
GG_API const GraphicStyle | GRAPHIC_NONE
GG_API const GraphicStyle | GRAPHIC_VCENTER
GG_API const GraphicStyle | GRAPHIC_TOP
GG_API const GraphicStyle | GRAPHIC_BOTTOM
GG_API const GraphicStyle | GRAPHIC_CENTER
GG_API const GraphicStyle | GRAPHIC_LEFT
GG_API const GraphicStyle | GRAPHIC_RIGHT
GG_API const GraphicStyle | GRAPHIC_FITGRAPHIC
GG_API const GraphicStyle | GRAPHIC_SHRINKFIT
GG_API const GraphicStyle | GRAPHIC_PROPSCALE
GG_API const WndFlag | INTERACTIVE
GG_API const WndFlag | REPEAT_BUTTON_DOWN
GG_API const WndFlag | DRAGABLE
GG_API const WndFlag | RESIZABLE
GG_API const WndFlag | ONTOP
GG_API const WndFlag | MODAL
GG_API const ModKey | MOD_KEY_NONE
GG_API const ModKey | MOD_KEY_LSHIFT
GG_API const ModKey | MOD_KEY_RSHIFT
GG_API const ModKey | MOD_KEY_LCTRL
GG_API const ModKey | MOD_KEY_RCTRL
GG_API const ModKey | MOD_KEY_LALT
GG_API const ModKey | MOD_KEY_RALT
GG_API const ModKey | MOD_KEY_LMETA
GG_API const ModKey | MOD_KEY_RMETA
GG_API const ModKey | MOD_KEY_NUM
GG_API const ModKey | MOD_KEY_CAPS
GG_API const ModKey | MOD_KEY_MODE
GG_API const Flags< ModKey > | MOD_KEY_CTRL
GG_API const Flags< ModKey > | MOD_KEY_SHIFT
GG_API const Flags< ModKey > | MOD_KEY_ALT
GG_API const Flags< ModKey > | MOD_KEY_META

## Detailed Description

The namespace that encloses all GG classes, functions, typedefs, enums, etc.

## Typedef Documentation

typedef boost::function<bool (adobe::name_t, const adobe::any_regular_t&)> GG::AdamDialogActionCallback

The modal dialog interface includes an API to call back to the client when a UI interaction occurs. In the definition of the GG dialog, there must be a slot that binds UI interactions (usually button presses, like Apply, Ok, or Cancel) to the generation of (adobe::name_t, adobe::any_regular_t) pairs. When such a UI interaction occurs, this callback is given the action name and value. The callback returns a bool specifying whether or not to close the dialog. If the callback returns true, the m_terminating_action field in the resulting AdamDialogResult will be the given action name.

Definition at line 103 of file AdamDlg.h.

typedef boost::function<bool (adobe::name_t, const adobe::any_regular_t&)> GG::ButtonHandler

The type of button click handle function expected by ExecuteModalDialog(). Handlers accept the name of the button clicked, the value emitted by the click as specified in the Adam and Eve scripts, and return true if the click should result in the closure of the dialog.

Definition at line 61 of file EveGlue.h.

## Enumeration Type Documentation

enum GG::AdamDialogDisplayOption

Display options to control whether a dialog is to be used during the playback of scripted command parameters.

Enumerator
ADAM_DIALOG_DISPLAY_ALWAYS | Show the dialog to the user in any instance
ADAM_DIALOG_DISPLAY_AS_NEEDED | Do not show the dialog to the user unless the command parameters are invalid for the model as currently specified. This allows for the user to modify the parameters and verify them before moving them on to the command.
ADAM_DIALOG_DISPLAY_NEVER | Do not show the user the dialog for any reason. In this instance when the parameter are invalid, error out of the playback.

Definition at line 53 of file AdamDlg.h.

enum GG::WndRegion

"Regions" of a window; used e.g. to determine direction(s) of drag when a window that has a drag-frame is clicked.

Definition at line 83 of file Base.h.

enum GG::Orientation

The orientations for scrollbars, sliders, etc.

Enumerator
VERTICAL | Vertical orientation.
HORIZONTAL | Horizontal orientation.

Definition at line 97 of file Base.h.

enum GG::StateButtonStyle

The built-in visual styles of state buttons.

Enumerator
SBSTYLE_3D_XBOX | Draws a down-beveled box with a 3D x-mark inside.
SBSTYLE_3D_CHECKBOX | Draws a down-beveled box with a 3D check-mark inside.
SBSTYLE_3D_RADIO | Draws a down-beveled circle with a 3D "dot" or "bubble" inside.
SBSTYLE_3D_BUTTON | Draws a button that toggles bewtween popped up and pushed down.
SBSTYLE_3D_ROUND_BUTTON | Draws a down-beveled circle with an up-beveled circle inside.
SBSTYLE_3D_TOP_ATTACHED_TAB | Draws an up-beveled rectagular tab that is brighter and larger when pressed; it's bottom is unbeveled.
SBSTYLE_3D_TOP_DETACHED_TAB | Draws an up-beveled rectagular tab that is brighter and larger when pressed; it's bottom is beveled.

Definition at line 103 of file Base.h.

enum GG::SliderLineStyle

The rendering styles of the line the tab slides over in a Slider.

Definition at line 120 of file Base.h.

enum GG::TabBarStyle

The styles of display for a TabBar.

Enumerator
TAB_BAR_ATTACHED | The currently active tab should appear to be connected to the area below the bar.
TAB_BAR_DETACHED | The currently active tab should appear to be unconnected to the area below the bar.

Definition at line 127 of file Base.h.

enum GG::Key

Adpated from SDLKey enum in SDL_keysym.h of the SDL library; capital letter keys added.

Definition at line 140 of file Base.h.

## Function Documentation

GG::GG_FLAG_TYPE | ( | Alignment |  | ) |

Alignment flags.

void GG::KeypadKeyToPrintable | ( | Key & | key,
|  | Flags< ModKey > | mod_keys
| ) |  |

Translates a printable key combination from a keypad press to the equivalent main-keyboard press. key is only modified if it is a keypad value. NumLock is taken into account. For instance, with numlock on, a GGK_KP7 (which is equal to a nonprintable char value) becomes a GGK_7 (which equals '7', and is printable).

Clr GG::FloatClr | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |
| inline

Named ctor that constructs a Clr from four floats that represent the color channels (each must be >= 0.0 and <= 1.0).

Definition at line 70 of file Clr.h.

bool GG::operator== | ( | const Clr & | rhs,
|  | const Clr & | lhs
| ) |  |
| inline

Returns true iff rhs and lhs are identical.

Definition at line 79 of file Clr.h.

References GG::Clr::a, GG::Clr::b, GG::Clr::g, and GG::Clr::r.

bool GG::operator!= | ( | const Clr & | rhs,
|  | const Clr & | lhs
| ) |  |
| inline

Returns true iff rhs and lhs are different.

Definition at line 83 of file Clr.h.

GG_API void GG::glColor | ( | Clr | clr | ) |

Calls the appropriate version of glColor*() with clr.

GG_API void GG::glVertex | ( | const Pt & | pt | ) |

Calls the appropriate version of glVertex*() with pt.

GG_API void GG::glVertex | ( | X | x,
|  | Y | y
| ) |  |

Calls the appropriate version of glVertex*() with x and y.

GG_API void GG::glVertex | ( | X_d | x,
|  | Y_d | y
| ) |  |

Calls the appropriate version of glVertex*() with x and y.

GG_API void GG::glVertex | ( | X | x,
|  | Y_d | y
| ) |  |

Calls the appropriate version of glVertex*() with x and y.

GG_API void GG::glVertex | ( | X_d | x,
|  | Y | y
| ) |  |

Calls the appropriate version of glVertex*() with x and y.

GG_API Clr GG::LightColor | ( | Clr | clr | ) |

Returns the lightened version of color clr. LightColor leaves the alpha channel unchanged, and multiplies the other channels by a some factor. (The factor is defined within LightColor().)

GG_API Clr GG::DarkColor | ( | Clr | clr | ) |

Returns the darkened version of color clr. DarkColor leaves the alpha channel unchanged, and divides the other channels by a some factor. (The factor is defined within DarkColor().)

GG_API Clr GG::DisabledColor | ( | Clr | clr | ) |

Returns the "disabled" (grayed) version of color clr. DisabledColor leaves the alpha channel unchanged, and adjusts the other channels in the direction of gray (GG_CLR_GRAY) by a factor between 0.0 and 1.0. (The factor is defined within DisabledColor().) This is used throughout the GG classes to render disabled controls.

Referenced by GG::Slider< T >::Render(), and GG::Spin< T >::Render().

GG_API void GG::BeginScissorClipping | ( | Pt | ul,
|  | Pt | lr
| ) |  |

Sets up a GL scissor box, so that everything outside of the screen region defined by points ul and lr is clipped out. These coordinates should be in GG screen coordinates, with +y downward, instead of GL's screen coordinates.

Note
  Failing to call EndScissorClipping() after calling this function and before the next unmatched glPopAttrib() call may produce unexpected results.

GG_API void GG::EndScissorClipping | ( |  | ) |

Ends the current GL scissor box, restoring GL scissor state to what it was before the corresponding call to BeginScissorClipping().

Precondition
  There must be an outstanding call to BeginScissorClipping().

GG_API void GG::BeginStencilClipping | ( | Pt | inner_ul,
|  | Pt | inner_lr,
|  | Pt | outer_ul,
|  | Pt | outer_lr
| ) |  |

Sets up a GL stencil, so that anything inside of the screen region defined by points inner_ul and inner_lr, or outside of the screen region defined by points outer_ul and outer_lr, is clipped out.

Note
  Failing to call EndStencilClipping() after calling this function and before the next unmatched glPopAttrib() call may produce unexpected results.
  An unnested call to BeginStencilClipping() will clear the stencil buffer.

Precondition
  There are no more than GL_STENCIL_BITS - 1 nested calls to BeginStencilClipping() currently outstanding (each nested call uses a separate bit in the stencil buffer).

GG_API void GG::EndStencilClipping | ( |  | ) |

Ends the current GL stencil, restoring GL stencil state to what it was before the corresponding call to BeginScissorClipping().

Precondition
  There must be an outstanding call to BeginStencilClipping().

GG_API void GG::FlatRectangle | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | Clr | border_color,
|  | unsigned int | border_thick = `2`
| ) |  |

Renders a rectangle starting at ul and ending just before lr, and assumes that OpenGL in in a "2D" state. The border is drawn in the desired thickness and color, then whatever is space is left inside that is filled with color color. No checking is done to make sure that border_thick * 2 is <= lr.x - ul.x (or <= lr.y - ul.y, for that matter). This method of drawing and the 2D requirements are true for all functions that follow.

Referenced by GG::Slider< T >::Render().

GG_API void GG::BeveledRectangle | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | Clr | border_color,
|  | bool | up,
|  | unsigned int | bevel_thick = `2`,
|  | bool | bevel_left = `true`,
|  | bool | bevel_top = `true`,
|  | bool | bevel_right = `true`,
|  | bool | bevel_bottom = `true`
| ) |  |

Like FlatRectangle(), but with a "beveled" appearance. The border_color used to create a lighter and a darker version of border_color, which are used to draw beveled edges around the inside of the rectangle to the desired thickness. If up is true, the beveled edges are lighter on the top and left, darker on the bottom and right, effecting a raised appearance. If up is false, the opposite happens, and the rectangle looks depressed. This is true of all the Beveled*() functions.

Referenced by GG::Slider< T >::Render(), and GG::Spin< T >::Render().

GG_API void GG::FlatCheck | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color
| ) |  |

Draws a checkmark used to draw state buttons.

GG_API void GG::BeveledCheck | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color
| ) |  |

Like FlatCheck(), but with a raised appearance.

GG_API void GG::FlatX | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color
| ) |  |

Draws an X-mark used to draw state buttons.

GG_API void GG::BeveledX | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color
| ) |  |

Like FlatX(), but with a raised appearance.

GG_API void GG::Bubble | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | bool | up = `true`
| ) |  |

Draws a disk that appears to be a portion of a lit sphere. The portion may appear raised or depressed.

GG_API void GG::FlatCircle | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | Clr | border_color,
|  | unsigned | thick = `2`
| ) |  |

Draws a circle of thick pixels thickness in the color specified.

GG_API void GG::BeveledCircle | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | Clr | border_color,
|  | bool | up = `true`,
|  | unsigned int | bevel_thick = `2`
| ) |  |

Draws a circle of thick pixels thickness in the color specified. The circle appears to be beveled, and may be beveled in such a way as to appear raised or depressed.

GG_API void GG::FlatRoundedRectangle | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | Clr | border_color,
|  | unsigned int | corner_radius = `5`,
|  | unsigned int | border_thick = `2`
| ) |  |

Draws a rounded rectangle of the specified thickness. The radius of the circles used to draw the corners is specified by corner_radius. Note that this means the rectangle should be at least 2 * corner_radius on a side, but as with all the other functions, no such check is performed.

GG_API void GG::BeveledRoundedRectangle | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | Clr | border_color,
|  | bool | up,
|  | unsigned int | corner_radius = `5`,
|  | unsigned int | bevel_thick = `2`
| ) |  |

Like the FlatRoundedRectangle() function, but beveled (raised or depressed).

GG_API void GG::BubbleRectangle | ( | Pt | ul,
|  | Pt | lr,
|  | Clr | color,
|  | bool | up,
|  | unsigned int | corner_radius = `5`
| ) |  |

Using the same techniques as in Bubble(), creates a rounded, bubbly rectangle.

template<class E >

EnumMap<E> GG::GetEnumMap | ( |  | ) |

Returns a map of the values of an enum to the corresponding string representation of that value.

Definition at line 72 of file Enum.h.

ModalDialogResult GG::ExecuteModalDialog | ( | std::istream & | eve_definition,
|  | std::istream & | adam_definition,
|  | ButtonHandler | handler
| ) |  |

Parses eve_definition and adam_definition, then instantiates and executes a modal dialog. Any buttons ... TODO handler documentation

Wnd* GG::MakeDialog | ( | std::istream & | eve_definition,
|  | std::istream & | adam_definition,
|  | ButtonHandler | handler
| ) |  |

Parses eve_definition and adam_definition, then instantiates and executes a modal dialog. Any buttons ... TODO handler documentation

template<class FlagType >

std::ostream & GG::operator<< | ( | std::ostream & | os,
|  | Flags< FlagType > | flags
| ) |  |

Writes flags to os in the format "flag1 | flag2 | ... flagn".

Definition at line 360 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator| | ( | Flags< FlagType > | lhs,
|  | Flags< FlagType > | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-or of lhs and rhs.

Definition at line 379 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator| | ( | Flags< FlagType > | lhs,
|  | FlagType | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-or of lhs and rhs.

Definition at line 389 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator| | ( | FlagType | lhs,
|  | Flags< FlagType > | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-or of lhs and rhs.

Definition at line 395 of file Flags.h.

template<class FlagType >

boost::enable_if< is_flag_type<FlagType>, Flags<FlagType>>::type GG::operator| | ( | FlagType | lhs,
|  | FlagType | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-or of lhs and rhs.

Definition at line 405 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator& | ( | Flags< FlagType > | lhs,
|  | Flags< FlagType > | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-and of lhs and rhs.

Definition at line 411 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator& | ( | Flags< FlagType > | lhs,
|  | FlagType | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-and of lhs and rhs.

Definition at line 421 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator& | ( | FlagType | lhs,
|  | Flags< FlagType > | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-and of lhs and rhs.

Definition at line 427 of file Flags.h.

template<class FlagType >

boost::enable_if< is_flag_type<FlagType>, Flags<FlagType>>::type GG::operator& | ( | FlagType | lhs,
|  | FlagType | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-and of lhs and rhs.

Definition at line 437 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator^ | ( | Flags< FlagType > | lhs,
|  | Flags< FlagType > | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-xor of lhs and rhs.

Definition at line 443 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator^ | ( | Flags< FlagType > | lhs,
|  | FlagType | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-xor of lhs and rhs.

Definition at line 453 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator^ | ( | FlagType | lhs,
|  | Flags< FlagType > | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-xor of lhs and rhs.

Definition at line 459 of file Flags.h.

template<class FlagType >

boost::enable_if< is_flag_type<FlagType>, Flags<FlagType>>::type GG::operator^ | ( | FlagType | lhs,
|  | FlagType | rhs
| ) |  |

Returns a Flags object that consists of the bitwise-xor of lhs and rhs.

Definition at line 469 of file Flags.h.

template<class FlagType >

Flags<FlagType> GG::operator~ | ( | Flags< FlagType > | flags | ) |

Returns a Flags object that consists of all the flags known to FlagSpec<FlagType>::instance() except those in flags.

Definition at line 475 of file Flags.h.

References GG::FlagSpec< FlagType >::begin(), GG::FlagSpec< FlagType >::end(), and GG::FlagSpec< FlagType >::instance().

template<class FlagType >

boost::enable_if< is_flag_type<FlagType>, Flags<FlagType>>::type GG::operator~ | ( | FlagType | flag | ) |

Returns a Flags object that consists of all the flags known to FlagSpec<FlagType>::instance() except flag.

Definition at line 493 of file Flags.h.

GG_API std::string GG::RgbaTag | ( | const Clr & | c | ) |

Returns a string of the form "<rgba r g b a>" from a Clr object with color channels r, b, g, a.

GG_API std::ostream& GG::operator<< | ( | std::ostream & | os,
|  | const Font::Substring & | substr
| ) |  |

Stream output operator for Font::Substring.

GG_API CPSize GG::CodePointIndexOf | ( | std::size_t | line,
|  | CPSize | index,
|  | const std::vector< Font::LineData > & | line_data
| ) |  |

Returns the code point index of the index-th code point on line line within the text represented by line_data. Returns the index of the code point one past the end of the text if line or index are out of bounds.

GG_API StrSize GG::StringIndexOf | ( | std::size_t | line,
|  | CPSize | index,
|  | const std::vector< Font::LineData > & | line_data
| ) |  |

Returns the string index of the index-th code point on line line within the text represented by line_data. Returns the index of the character one past the end of the text if line or index are out of bounds.

GG_API std::pair<std::size_t, CPSize> GG::LinePositionOf | ( | CPSize | index,
|  | const std::vector< Font::LineData > & | line_data
| ) |  |

Returns the line L and the code point index within L of the index-th code point within the text represented by line_data. Returns (std::numeric_limits<std::size_t>::max(), INVALID_CP_SIZE) if index is out of bounds.

GG_API FontManager& GG::GetFontManager | ( |  | ) |

Returns the singleton FontManager instance.

Referenced by GG::GUI::GetFont().

GG::GG_EXCEPTION | ( | FailedFTLibraryInit |  | ) |

Thrown when initialization of the FreeType library fails.

GG::GG_FLAG_TYPE | ( | TextFormat |  | ) |

Text formatting flags.

GG_API bool GG::MatchesOrContains | ( | const Wnd * | lwnd,
|  | const Wnd * | rwnd
| ) |  |

Returns true if lwnd == rwnd or if lwnd contains rwnd

GG::GG_FLAG_TYPE | ( | ListBoxStyle |  | ) |

Styles for ListBox controls.

GG::GG_FLAG_TYPE | ( | MultiEditStyle |  | ) |

The styles of display and interaction for a MultiEdit.

GG_API PluginManager& GG::GetPluginManager | ( |  | ) |

Returns the singleton PluginManager instance.

GG_API bool GG::operator== | ( | const Rect & | lhs,
|  | const Rect & | rhs
| ) |  |
| inline

returns true if lhs is identical to rhs

Definition at line 129 of file PtRect.h.

References GG::Rect::lr, GG::Rect::ul, GG::Pt::x, and GG::Pt::y.

GG_API bool GG::operator!= | ( | const Rect & | lhs,
|  | const Rect & | rhs
| ) |  |
| inline

returns true if lhs differs from rhs

Definition at line 132 of file PtRect.h.

GG_ENUM_MAP_END GG_API void GG::SignalScroll | ( | const Scroll & | scroll,
|  | bool | stopped
| ) |  |

A convenience function that signals scroll's position, via Scroll::ScrolledSignal. If stopped is true, the position is additionally signalled on Scroll::ScrolledAndStoppedSignal.

template<class SigT >

boost::signals::connection GG::Connect | ( | SigT & | sig,
|  | const typename SigT::slot_type & | _slot,
|  | boost::signals::connect_position | at = `boost::signals::at_back`
| ) |  |
| inline

Connects a signal to a slot functor of the same signature, putting _slot in slot group 0, at position at within group 0. Slot call groups are called in ascending order.

Definition at line 52 of file SignalsAndSlots.h.

Referenced by GG::Spin< T >::Spin().

template<class SigT >

boost::signals::connection GG::Connect | ( | SigT & | sig,
|  | const typename SigT::slot_type & | _slot,
|  | int | grp,
|  | boost::signals::connect_position | at = `boost::signals::at_back`
| ) |  |
| inline

Connects a signal to a slot functor of the same signature, putting _slot in slot group grp, at position at within group grp. Slot call groups are called in ascending order.

Definition at line 62 of file SignalsAndSlots.h.

GG::GG_FLAG_TYPE | ( | GraphicStyle |  | ) |

Styles for StaticGraphic controls.

int GG::Value | ( | int | i | ) |
| inline

Overload of Value() for int.

Definition at line 42 of file StrongTypedef.h.

Referenced by GG::Slider< T >::MoveTabToPosn(), GG::Slider< T >::PtToPosn(), and GG::Slider< T >::Render().

double GG::Value | ( | double | d | ) |
| inline

Overload of Value() for double.

Definition at line 46 of file StrongTypedef.h.

std::size_t GG::Value | ( | std::size_t | s | ) |
| inline

Overload of Value() for std::size_t.

Definition at line 50 of file StrongTypedef.h.

TextureManager& GG::GetTextureManager | ( |  | ) |

Returns the singleton TextureManager instance.

GG_API bool GG::operator== | ( | const UnicodeCharset & | lhs,
|  | const UnicodeCharset & | rhs
| ) |  |

Returns true iff all of lhs's and rhs's members compare equal.

GG_API bool GG::operator< | ( | const UnicodeCharset & | lhs,
|  | const UnicodeCharset & | rhs
| ) |  |

Returns true iff lhs.m_first_char < rhs.m_first_char.

GG_API const std::vector<UnicodeCharset>& GG::AllUnicodeCharsets | ( |  | ) |

Returns a vector containing all defined UnicodeCharset's.

GG_API std::set<UnicodeCharset> GG::UnicodeCharsetsToRender | ( | const std::string & | str | ) |

Returns the set of the UnicodeCharset's required to render str.

GG_API const UnicodeCharset* GG::CharsetContaining | ( | boost::uint32_t | c | ) |

Returns the UnicodeCharset in which c can be found, or 0 if no such UnicodeCharset exists.

GG_API const UnicodeCharset* GG::CharsetWithName | ( | const std::string & | name | ) |

Returns the UnicodeCharset called name, or 0 if no such UnicodeCharset exists.

GG::GG_FLAG_TYPE | ( | WndFlag |  | ) |

Wnd creation flags type.

## Variable Documentation

GG_API const WndFlag GG::INTERACTIVE

Clicks hit this window, rather than passing through it, and mouse-overs detect that they are over this window.

GG_API const WndFlag GG::REPEAT_BUTTON_DOWN

When a mouse button is held down over this window, it expects to receive multiple *ButtonDown messages.

GG_API const WndFlag GG::DRAGABLE

This window can be dragged around independently.

GG_API const WndFlag GG::RESIZABLE

This window can be resized by the user, with the mouse.

GG_API const WndFlag GG::ONTOP

This windows is an "on-top" window, and will always appear above all non-on-top and non-modal windows. Note that this only applies to top-level (Parent()-less) Wnds.

GG_API const WndFlag GG::MODAL

This window is modal; while it is active, no other windows are interactive. Modal windows are considered above "on-top" windows, and should not be flagged as OnTop. Note that this only applies to top-level (Parent()-less) Wnds.